Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 6721)
@@ -37,37 +37,37 @@
 
     #region Job Methods
-    public DT.Job GetJob(Guid id) {
-      using (var db = CreateContext()) {
-        return DT.Convert.ToDto(db.Jobs.SingleOrDefault(x => x.JobId == id));
-      }
-    }
-
-    public IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate) {
-      using (var db = CreateContext()) {
-        return db.Jobs.Where(predicate).Select(x => DT.Convert.ToDto(x)).ToArray();
-      }
-    }
-
-    public Guid AddJob(DT.Job dto) {
-      using (var db = CreateContext()) {
-        var entity = DT.Convert.ToEntity(dto);
-        db.Jobs.InsertOnSubmit(entity);
+    public DT.Task GetJob(Guid id) {
+      using (var db = CreateContext()) {
+        return DT.Convert.ToDto(db.Tasks.SingleOrDefault(x => x.TaskId == id));
+      }
+    }
+
+    public IEnumerable<DT.Task> GetJobs(Expression<Func<Task, bool>> predicate) {
+      using (var db = CreateContext()) {
+        return db.Tasks.Where(predicate).Select(x => DT.Convert.ToDto(x)).ToArray();
+      }
+    }
+
+    public Guid AddJob(DT.Task dto) {
+      using (var db = CreateContext()) {
+        var entity = DT.Convert.ToEntity(dto);
+        db.Tasks.InsertOnSubmit(entity);
         db.SubmitChanges();
         foreach (Guid pluginId in dto.PluginsNeededIds) {
-          db.RequiredPlugins.InsertOnSubmit(new RequiredPlugin() { JobId = entity.JobId, PluginId = pluginId });
-        }
-        db.SubmitChanges();
-        return entity.JobId;
-      }
-    }
-
-    public void UpdateJob(DT.Job dto) {
-      using (var db = CreateContext()) {
-        var entity = db.Jobs.FirstOrDefault(x => x.JobId == dto.Id);
-        if (entity == null) db.Jobs.InsertOnSubmit(DT.Convert.ToEntity(dto));
+          db.RequiredPlugins.InsertOnSubmit(new RequiredPlugin() { TaskId = entity.TaskId, PluginId = pluginId });
+        }
+        db.SubmitChanges();
+        return entity.TaskId;
+      }
+    }
+
+    public void UpdateJob(DT.Task dto) {
+      using (var db = CreateContext()) {
+        var entity = db.Tasks.FirstOrDefault(x => x.TaskId == dto.Id);
+        if (entity == null) db.Tasks.InsertOnSubmit(DT.Convert.ToEntity(dto));
         else DT.Convert.ToEntity(dto, entity);
         foreach (Guid pluginId in dto.PluginsNeededIds) {
           if (db.RequiredPlugins.Count(p => p.PluginId == pluginId) == 0) {
-            db.RequiredPlugins.InsertOnSubmit(new RequiredPlugin() { JobId = entity.JobId, PluginId = pluginId });
+            db.RequiredPlugins.InsertOnSubmit(new RequiredPlugin() { TaskId = entity.TaskId, PluginId = pluginId });
           }
         }
@@ -78,6 +78,6 @@
     public void DeleteJob(Guid id) {
       using (var db = CreateContext()) {
-        var entity = db.Jobs.FirstOrDefault(x => x.JobId == id);
-        if (entity != null) db.Jobs.DeleteOnSubmit(entity);
+        var entity = db.Tasks.FirstOrDefault(x => x.TaskId == id);
+        if (entity != null) db.Tasks.DeleteOnSubmit(entity);
         db.SubmitChanges(); // JobData and child jobs are deleted by db-trigger
       }
@@ -91,26 +91,26 @@
     /// <param name="finished">if true, all parent jobs which have FinishWhenChildJobsFinished=true are returned, otherwise only FinishWhenChildJobsFinished=false are returned</param>
     /// <returns></returns>
-    public IEnumerable<DT.Job> GetParentJobs(IEnumerable<Guid> resourceIds, int count, bool finished) {
+    public IEnumerable<DT.Task> GetParentJobs(IEnumerable<Guid> resourceIds, int count, bool finished) {
       using (var db = CreateContext()) {
         var query = from ar in db.AssignedResources
                     where resourceIds.Contains(ar.ResourceId)
-                       && ar.Job.State == JobState.Waiting
-                       && ar.Job.IsParentJob
-                       && (finished ? ar.Job.FinishWhenChildJobsFinished : !ar.Job.FinishWhenChildJobsFinished)
-                       && (from child in db.Jobs
-                           where child.ParentJobId == ar.Job.JobId
-                           select child.State == JobState.Finished
-                               || child.State == JobState.Aborted
-                               || child.State == JobState.Failed).All(x => x)
-                       && (from child in db.Jobs // avoid returning WaitForChildJobs jobs where no child-jobs exist (yet)
-                           where child.ParentJobId == ar.Job.JobId
+                       && ar.Task.State == TaskState.Waiting
+                       && ar.Task.IsParentTask
+                       && (finished ? ar.Task.FinishWhenChildJobsFinished : !ar.Task.FinishWhenChildJobsFinished)
+                       && (from child in db.Tasks
+                           where child.ParentTaskId == ar.Task.TaskId
+                           select child.State == TaskState.Finished
+                               || child.State == TaskState.Aborted
+                               || child.State == TaskState.Failed).All(x => x)
+                       && (from child in db.Tasks // avoid returning WaitForChildJobs jobs where no child-jobs exist (yet)
+                           where child.ParentTaskId == ar.Task.TaskId
                            select child).Count() > 0
-                    orderby ar.Job.Priority descending, db.Random()
-                    select DT.Convert.ToDto(ar.Job);
+                    orderby ar.Task.Priority descending, db.Random()
+                    select DT.Convert.ToDto(ar.Task);
         return count == 0 ? query.ToArray() : query.Take(count).ToArray();
       }
     }
 
-    public IEnumerable<DT.Job> GetWaitingJobs(DT.Slave slave, int count) {
+    public IEnumerable<DT.Task> GetWaitingJobs(DT.Slave slave, int count) {
       using (var db = CreateContext()) {
         var resourceIds = GetParentResources(slave.Id).Select(r => r.Id);
@@ -120,10 +120,10 @@
         var query = from ar in db.AssignedResources
                     where resourceIds.Contains(ar.ResourceId)
-                       && !(ar.Job.IsParentJob && ar.Job.FinishWhenChildJobsFinished)
-                       && ar.Job.State == JobState.Waiting
-                       && ar.Job.CoresNeeded <= slave.FreeCores
-                       && ar.Job.MemoryNeeded <= slave.FreeMemory
-                    orderby ar.Job.Priority descending, db.Random() // take random job to avoid the race condition that occurs when this method is called concurrently (the same job would be returned)
-                    select DT.Convert.ToDto(ar.Job);
+                       && !(ar.Task.IsParentTask && ar.Task.FinishWhenChildJobsFinished)
+                       && ar.Task.State == TaskState.Waiting
+                       && ar.Task.CoresNeeded <= slave.FreeCores
+                       && ar.Task.MemoryNeeded <= slave.FreeMemory
+                    orderby ar.Task.Priority descending, db.Random() // take random job to avoid the race condition that occurs when this method is called concurrently (the same job would be returned)
+                    select DT.Convert.ToDto(ar.Task);
         var waitingJobs = (count == 0 ? query : query.Take(count)).ToArray();
         return waitingJobs.Union(waitingParentJobs).OrderByDescending(x => x.Priority);
@@ -131,10 +131,10 @@
     }
 
-    public DT.Job UpdateJobState(Guid jobId, JobState jobState, Guid? slaveId, Guid? userId, string exception) {
-      using (var db = CreateContext()) {
-        var job = db.Jobs.SingleOrDefault(x => x.JobId == jobId);
+    public DT.Task UpdateJobState(Guid jobId, TaskState jobState, Guid? slaveId, Guid? userId, string exception) {
+      using (var db = CreateContext()) {
+        var job = db.Tasks.SingleOrDefault(x => x.TaskId == jobId);
         job.State = jobState;
         db.StateLogs.InsertOnSubmit(new StateLog {
-          JobId = jobId,
+          TaskId = jobId,
           State = jobState,
           SlaveId = slaveId,
@@ -144,5 +144,5 @@
         });
         db.SubmitChanges();
-        job = db.Jobs.SingleOrDefault(x => x.JobId == jobId);
+        job = db.Tasks.SingleOrDefault(x => x.TaskId == jobId);
         return DT.Convert.ToDto(job);
       }
@@ -151,29 +151,29 @@
 
     #region JobData Methods
-    public DT.JobData GetJobData(Guid id) {
+    public DT.TaskData GetJobData(Guid id) {
       using (var db = CreateContext(true)) {
-        return DT.Convert.ToDto(db.JobDatas.SingleOrDefault(x => x.JobId == id));
-      }
-    }
-
-    public IEnumerable<DT.JobData> GetJobDatas(Expression<Func<JobData, bool>> predicate) {
+        return DT.Convert.ToDto(db.TaskDatas.SingleOrDefault(x => x.TaskId == id));
+      }
+    }
+
+    public IEnumerable<DT.TaskData> GetJobDatas(Expression<Func<TaskData, bool>> predicate) {
       using (var db = CreateContext(true)) {
-        return db.JobDatas.Where(predicate).Select(x => DT.Convert.ToDto(x)).ToArray();
-      }
-    }
-
-    public Guid AddJobData(DT.JobData dto) {
+        return db.TaskDatas.Where(predicate).Select(x => DT.Convert.ToDto(x)).ToArray();
+      }
+    }
+
+    public Guid AddJobData(DT.TaskData dto) {
       using (var db = CreateContext(true)) {
         var entity = DT.Convert.ToEntity(dto);
-        db.JobDatas.InsertOnSubmit(entity);
-        db.SubmitChanges();
-        return entity.JobId;
-      }
-    }
-
-    public void UpdateJobData(DT.JobData dto) {
+        db.TaskDatas.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.TaskId;
+      }
+    }
+
+    public void UpdateJobData(DT.TaskData dto) {
       using (var db = CreateContext(true)) {
-        var entity = db.JobDatas.FirstOrDefault(x => x.JobId == dto.JobId);
-        if (entity == null) db.JobDatas.InsertOnSubmit(DT.Convert.ToEntity(dto));
+        var entity = db.TaskDatas.FirstOrDefault(x => x.TaskId == dto.TaskId);
+        if (entity == null) db.TaskDatas.InsertOnSubmit(DT.Convert.ToEntity(dto));
         else DT.Convert.ToEntity(dto, entity);
         db.SubmitChanges();
@@ -183,6 +183,6 @@
     public void DeleteJobData(Guid id) {
       using (var db = CreateContext()) {
-        var entity = db.JobDatas.FirstOrDefault(x => x.JobId == id); // check if all the byte[] is loaded into memory here. otherwise work around to delete without loading it
-        if (entity != null) db.JobDatas.DeleteOnSubmit(entity);
+        var entity = db.TaskDatas.FirstOrDefault(x => x.TaskId == id); // check if all the byte[] is loaded into memory here. otherwise work around to delete without loading it
+        if (entity != null) db.TaskDatas.DeleteOnSubmit(entity);
         db.SubmitChanges();
       }
@@ -241,8 +241,8 @@
         return null;
 
-      var jobs = db.Jobs.Where(j => j.HiveExperimentId == exp.Id);
+      var jobs = db.Tasks.Where(j => j.HiveExperimentId == exp.Id);
       exp.JobCount = jobs.Count();
-      exp.CalculatingCount = jobs.Count(j => j.State == JobState.Calculating);
-      exp.FinishedCount = jobs.Count(j => j.State == JobState.Finished);
+      exp.CalculatingCount = jobs.Count(j => j.State == TaskState.Calculating);
+      exp.FinishedCount = jobs.Count(j => j.State == TaskState.Finished);
       return exp;
     }
@@ -554,6 +554,6 @@
     public void AssignJobToResource(Guid jobId, Guid resourceId) {
       using (var db = CreateContext()) {
-        var job = db.Jobs.Where(x => x.JobId == jobId).Single();
-        job.AssignedResources.Add(new AssignedResource() { JobId = jobId, ResourceId = resourceId });
+        var job = db.Tasks.Where(x => x.TaskId == jobId).Single();
+        job.AssignedResources.Add(new AssignedResource() { TaskId = jobId, ResourceId = resourceId });
         db.SubmitChanges();
       }
@@ -562,5 +562,5 @@
     public IEnumerable<DT.Resource> GetAssignedResources(Guid jobId) {
       using (var db = CreateContext()) {
-        var job = db.Jobs.Where(x => x.JobId == jobId).Single();
+        var job = db.Tasks.Where(x => x.TaskId == jobId).Single();
         return job.AssignedResources.Select(x => DT.Convert.ToDto(x.Resource)).ToArray();
       }
@@ -598,11 +598,11 @@
     }
 
-    public IEnumerable<DT.Job> GetJobsByResourceId(Guid resourceId) {
+    public IEnumerable<DT.Task> GetJobsByResourceId(Guid resourceId) {
       using (var db = CreateContext()) {
         var resources = GetChildResources(resourceId).Select(x => x.Id).ToList();
         resources.Add(resourceId);
 
-        var jobs = db.Jobs.Where(j =>
-          j.State == JobState.Calculating &&
+        var jobs = db.Tasks.Where(j =>
+          j.State == TaskState.Calculating &&
           j.StateLogs.OrderByDescending(x => x.DateTime).First().SlaveId.HasValue &&
           resources.Contains(j.StateLogs.OrderByDescending(x => x.DateTime).First().SlaveId.Value));
@@ -631,5 +631,5 @@
     public Guid GetExperimentForJob(Guid jobId) {
       using (var db = CreateContext()) {
-        return db.Jobs.Single(j => j.JobId == jobId).HiveExperimentId;
+        return db.Tasks.Single(j => j.TaskId == jobId).HiveExperimentId;
       }
     }
@@ -743,6 +743,6 @@
         var userStats = new Dictionary<Guid, DT.UserStatistics>();
 
-        var usedCoresByUser = from job in db.Jobs
-                              where job.State == JobState.Calculating
+        var usedCoresByUser = from job in db.Tasks
+                              where job.State == TaskState.Calculating
                               group job by job.HiveExperiment.OwnerUserId into g
                               select new { UserId = g.Key, UsedCores = g.Count() };
@@ -755,5 +755,5 @@
         }
 
-        var executionTimesByUser = from job in db.Jobs
+        var executionTimesByUser = from job in db.Tasks
                                    group job by job.HiveExperiment.OwnerUserId into g
                                    select new { UserId = g.Key, ExecutionTime = TimeSpan.FromMilliseconds(g.Select(x => x.ExecutionTimeMs).Sum()) };
@@ -766,6 +766,6 @@
 
         // execution times only of finished jobs - necessary to compute efficieny
-        var executionTimesFinishedJobs = from job in db.Jobs
-                                         where job.State == JobState.Finished
+        var executionTimesFinishedJobs = from job in db.Tasks
+                                         where job.State == TaskState.Finished
                                          group job by job.HiveExperiment.OwnerUserId into g
                                          select new { UserId = g.Key, ExecutionTimeFinishedJobs = TimeSpan.FromMilliseconds(g.Select(x => x.ExecutionTimeMs).Sum()) };
@@ -779,6 +779,6 @@
 
         // start to end times only of finished jobs - necessary to compute efficiency
-        var startToEndTimesFinishedJobs = from job in db.Jobs
-                                          where job.State == JobState.Finished
+        var startToEndTimesFinishedJobs = from job in db.Tasks
+                                          where job.State == TaskState.Finished
                                           group job by job.HiveExperiment.OwnerUserId into g
                                           select new {
@@ -817,10 +817,10 @@
 
     #region Helpers
-    private void CollectChildJobs(HiveDataContext db, Guid parentJobId, List<Job> collection) {
-      var jobs = db.Jobs.Where(j => j.ParentJobId == parentJobId);
+    private void CollectChildJobs(HiveDataContext db, Guid parentJobId, List<Task> collection) {
+      var jobs = db.Tasks.Where(j => j.ParentTaskId == parentJobId);
       foreach (var job in jobs) {
         collection.Add(job);
-        if (job.IsParentJob)
-          CollectChildJobs(db, job.JobId, collection);
+        if (job.IsParentTask)
+          CollectChildJobs(db, job.TaskId, collection);
       }
     }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 6721)
@@ -61,9 +61,9 @@
 
     #region Job Methods
-    public Guid AddJob(Job job, JobData jobData, IEnumerable<Guid> resourceIds) {
+    public Guid AddJob(Task job, TaskData jobData, IEnumerable<Guid> resourceIds) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
         job.Id = dao.AddJob(job);
-        jobData.JobId = job.Id;
+        jobData.TaskId = job.Id;
         jobData.LastUpdate = DateTime.Now;
         foreach (Guid slaveGroupId in resourceIds) {
@@ -71,18 +71,18 @@
         }
         dao.AddJobData(jobData);
-        dao.UpdateJobState(job.Id, DA.JobState.Waiting, null, userManager.CurrentUserId, null);
-        return jobData.JobId;
+        dao.UpdateJobState(job.Id, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
+        return jobData.TaskId;
       }, false, true);
     }
 
-    public Guid AddChildJob(Guid parentJobId, Job job, JobData jobData) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => {
-        job.ParentJobId = parentJobId;
+    public Guid AddChildJob(Guid parentJobId, Task job, TaskData jobData) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      return trans.UseTransaction(() => {
+        job.ParentTaskId = parentJobId;
         return AddJob(job, jobData, dao.GetAssignedResources(parentJobId).Select(x => x.Id));
       }, false, true);
     }
 
-    public Job GetJob(Guid jobId) {
+    public Task GetJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForJob(jobId, Permission.Read);
@@ -90,5 +90,5 @@
     }
 
-    public IEnumerable<Job> GetJobs() {
+    public IEnumerable<Task> GetJobs() {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       var jobs = dao.GetJobs(x => true);
@@ -98,7 +98,7 @@
     }
 
-    public IEnumerable<LightweightJob> GetLightweightJobs(IEnumerable<Guid> jobIds) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      var jobs = dao.GetJobs(x => jobIds.Contains(x.JobId)).Select(x => new LightweightJob(x)).ToArray();
+    public IEnumerable<LightweightTask> GetLightweightJobs(IEnumerable<Guid> jobIds) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var jobs = dao.GetJobs(x => jobIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
       foreach (var job in jobs)
         author.AuthorizeForJob(job.Id, Permission.Read);
@@ -106,7 +106,7 @@
     }
 
-    public IEnumerable<LightweightJob> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      var jobs = GetChildJobs(parentJobId, recursive, includeParent).Select(x => new LightweightJob(x)).ToArray();
+    public IEnumerable<LightweightTask> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var jobs = GetChildJobs(parentJobId, recursive, includeParent).Select(x => new LightweightTask(x)).ToArray();
       foreach (var job in jobs)
         author.AuthorizeForJob(job.Id, Permission.Read);
@@ -114,11 +114,11 @@
     }
 
-    public IEnumerable<LightweightJob> GetLightweightExperimentJobs(Guid experimentId) {
+    public IEnumerable<LightweightTask> GetLightweightExperimentJobs(Guid experimentId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       author.AuthorizeForExperiment(experimentId, Permission.Read);
-      return dao.GetJobs(x => x.HiveExperimentId == experimentId).Select(x => new LightweightJob(x)).ToArray();
-    }
-
-    public JobData GetJobData(Guid jobId) {
+      return dao.GetJobs(x => x.HiveExperimentId == experimentId).Select(x => new LightweightTask(x)).ToArray();
+    }
+
+    public TaskData GetJobData(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForJob(jobId, Permission.Read);
@@ -126,5 +126,5 @@
     }
 
-    public void UpdateJob(Job job) {
+    public void UpdateJob(Task job) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForJob(job.Id, Permission.Full);
@@ -134,8 +134,8 @@
     }
 
-    public void UpdateJobData(Job job, JobData jobData) {
+    public void UpdateJobData(Task job, TaskData jobData) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForJob(job.Id, Permission.Full);
-      author.AuthorizeForJob(jobData.JobId, Permission.Full);
+      author.AuthorizeForJob(jobData.TaskId, Permission.Full);
       //trans.UseTransaction(() => { // cneumuel: try without transaction
       jobData.LastUpdate = DateTime.Now;
@@ -165,19 +165,19 @@
     }
 
-    public Job UpdateJobState(Guid jobId, JobState jobState, Guid? slaveId, Guid? userId, string exception) {
+    public Task UpdateJobState(Guid jobId, TaskState jobState, Guid? slaveId, Guid? userId, string exception) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForJob(jobId, Permission.Full);
       return trans.UseTransaction(() => {
-        Job job = dao.UpdateJobState(jobId, DataTransfer.Convert.ToEntity(jobState), slaveId, userId, exception);
-
-        if (job.Command.HasValue && job.Command.Value == Command.Pause && job.State == JobState.Paused) {
+        Task job = dao.UpdateJobState(jobId, DataTransfer.Convert.ToEntity(jobState), slaveId, userId, exception);
+
+        if (job.Command.HasValue && job.Command.Value == Command.Pause && job.State == TaskState.Paused) {
           job.Command = null;
-        } else if (job.Command.HasValue && job.Command.Value == Command.Abort && job.State == JobState.Aborted) {
+        } else if (job.Command.HasValue && job.Command.Value == Command.Abort && job.State == TaskState.Aborted) {
           job.Command = null;
-        } else if (job.Command.HasValue && job.Command.Value == Command.Stop && job.State == JobState.Aborted) {
+        } else if (job.Command.HasValue && job.Command.Value == Command.Stop && job.State == TaskState.Aborted) {
           job.Command = null;
-        } else if (jobState == JobState.Paused && !job.Command.HasValue) {
+        } else if (jobState == TaskState.Paused && !job.Command.HasValue) {
           // slave paused and uploaded the job (no user-command) -> set waiting.
-          job = dao.UpdateJobState(jobId, DataTransfer.Convert.ToEntity(JobState.Waiting), slaveId, userId, exception);
+          job = dao.UpdateJobState(jobId, DataTransfer.Convert.ToEntity(TaskState.Waiting), slaveId, userId, exception);
         }
 
@@ -187,5 +187,5 @@
     }
 
-    public IEnumerable<Job> GetJobsByResourceId(Guid resourceId) {
+    public IEnumerable<Task> GetJobsByResourceId(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       var jobs = trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
@@ -202,10 +202,10 @@
       trans.UseTransaction(() => {
         var job = dao.GetJob(jobId);
-        if (job.State == JobState.Calculating || job.State == JobState.Transferring) {
+        if (job.State == TaskState.Calculating || job.State == TaskState.Transferring) {
           job.Command = Command.Stop;
           dao.UpdateJob(job);
         } else {
-          if (job.State != JobState.Aborted && job.State != JobState.Finished && job.State != JobState.Failed) {
-            job = UpdateJobState(jobId, JobState.Aborted, null, null, string.Empty);
+          if (job.State != TaskState.Aborted && job.State != TaskState.Finished && job.State != TaskState.Failed) {
+            job = UpdateJobState(jobId, TaskState.Aborted, null, null, string.Empty);
           }
         }
@@ -218,9 +218,9 @@
       trans.UseTransaction(() => {
         var job = dao.GetJob(jobId);
-        if (job.State == JobState.Calculating || job.State == JobState.Transferring) {
+        if (job.State == TaskState.Calculating || job.State == TaskState.Transferring) {
           job.Command = Command.Pause;
           dao.UpdateJob(job);
         } else {
-          job = UpdateJobState(jobId, JobState.Paused, null, null, string.Empty);
+          job = UpdateJobState(jobId, TaskState.Paused, null, null, string.Empty);
         }
       });
@@ -231,5 +231,5 @@
       author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
-        Job job = dao.UpdateJobState(jobId, DA.JobState.Waiting, null, userManager.CurrentUserId, string.Empty);
+        Task job = dao.UpdateJobState(jobId, DA.TaskState.Waiting, null, userManager.CurrentUserId, string.Empty);
         job.Command = null;
         dao.UpdateJob(job);
@@ -591,9 +591,9 @@
 
     #region Helper Methods
-    private IEnumerable<Job> GetChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
-      var jobs = new List<Job>(dao.GetJobs(x => parentJobId == null ? !x.ParentJobId.HasValue : x.ParentJobId.Value == parentJobId));
+    private IEnumerable<Task> GetChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
+      var jobs = new List<Task>(dao.GetJobs(x => parentJobId == null ? !x.ParentTaskId.HasValue : x.ParentTaskId.Value == parentJobId));
 
       if (recursive) {
-        var childs = new List<Job>();
+        var childs = new List<Task>();
         foreach (var job in jobs) {
           childs.AddRange(GetChildJobs(job.Id, recursive, false));
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs	(revision 6721)
@@ -29,19 +29,19 @@
   public interface IHiveDao {
     #region Job Methods
-    DT.Job GetJob(Guid id);
-    IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate);
-    Guid AddJob(DT.Job dto);
-    void UpdateJob(DT.Job dto);
+    DT.Task GetJob(Guid id);
+    IEnumerable<DT.Task> GetJobs(Expression<Func<Task, bool>> predicate);
+    Guid AddJob(DT.Task dto);
+    void UpdateJob(DT.Task dto);
     void DeleteJob(Guid id);
-    IEnumerable<DT.Job> GetWaitingJobs(DT.Slave slave, int count);
-    IEnumerable<DT.Job> GetParentJobs(IEnumerable<Guid> resourceIds, int count, bool finished);
-    DT.Job UpdateJobState(Guid jobId, JobState jobState, Guid? slaveId, Guid? userId, string exception);
+    IEnumerable<DT.Task> GetWaitingJobs(DT.Slave slave, int count);
+    IEnumerable<DT.Task> GetParentJobs(IEnumerable<Guid> resourceIds, int count, bool finished);
+    DT.Task UpdateJobState(Guid jobId, TaskState jobState, Guid? slaveId, Guid? userId, string exception);
     #endregion
 
     #region JobData Methods
-    DT.JobData GetJobData(Guid id);
-    IEnumerable<DT.JobData> GetJobDatas(Expression<Func<JobData, bool>> predicate);
-    Guid AddJobData(DT.JobData dto);
-    void UpdateJobData(DT.JobData dto);
+    DT.TaskData GetJobData(Guid id);
+    IEnumerable<DT.TaskData> GetJobDatas(Expression<Func<TaskData, bool>> predicate);
+    Guid AddJobData(DT.TaskData dto);
+    void UpdateJobData(DT.TaskData dto);
     void DeleteJobData(Guid id);
     #endregion
@@ -117,5 +117,5 @@
     IEnumerable<DT.Resource> GetParentResources(Guid resourceId);
     IEnumerable<DT.Resource> GetChildResources(Guid resourceId);
-    IEnumerable<DT.Job> GetJobsByResourceId(Guid resourceId);
+    IEnumerable<DT.Task> GetJobsByResourceId(Guid resourceId);
     #endregion
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 6721)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Services.Hive.DataAccess;
 using HeuristicLab.Services.Hive.DataAccess;
 using DT = HeuristicLab.Services.Hive.DataTransfer;
@@ -92,12 +91,12 @@
       var parentJobsToFinish = dao.GetParentJobs(dao.GetResources(x => true).Select(x => x.Id), 0, true);
       foreach (var job in parentJobsToFinish) {
-        dao.UpdateJobState(job.Id, JobState.Finished, null, null, string.Empty);
+        dao.UpdateJobState(job.Id, TaskState.Finished, null, null, string.Empty);
       }
     }
 
     private void SetJobsWaiting(Guid slaveId) {
-      var jobs = dao.GetJobs(x => x.State == JobState.Calculating).Where(x => x.StateLog.Last().SlaveId == slaveId);
+      var jobs = dao.GetJobs(x => x.State == TaskState.Calculating).Where(x => x.StateLog.Last().SlaveId == slaveId);
       foreach (var j in jobs) {
-        DT.Job job = dao.UpdateJobState(j.Id, JobState.Waiting, slaveId, null, "Slave timed out.");
+        DT.Task job = dao.UpdateJobState(j.Id, TaskState.Waiting, slaveId, null, "Slave timed out.");
         job.Command = null;
         dao.UpdateJob(job);
@@ -109,8 +108,8 @@
     /// </summary>
     private void SetTimeoutJobsWaiting() {
-      var jobs = dao.GetJobs(x => (x.State == JobState.Calculating && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.CalculatingJobHeartbeatTimeout)
-                               || (x.State == JobState.Transferring && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.TransferringJobHeartbeatTimeout));
+      var jobs = dao.GetJobs(x => (x.State == TaskState.Calculating && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.CalculatingJobHeartbeatTimeout)
+                               || (x.State == TaskState.Transferring && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.TransferringJobHeartbeatTimeout));
       foreach (var j in jobs) {
-        DT.Job job = dao.UpdateJobState(j.Id, JobState.Waiting, null, null, "Slave timed out.");
+        DT.Task job = dao.UpdateJobState(j.Id, TaskState.Waiting, null, null, "Slave timed out.");
         job.Command = null;
         dao.UpdateJob(job);
